Description

The current implementation of Enumerator:select fails when applied to an open ended Enumerator:Generator,

resulting in an endless loop.

In the current implementation, :select seems to collect all values from the enumerator before applying the selection.

If that Enumeration is not bound, this results in an endless loop.

Instead, applying :select to a Generator should be applied to each object in turn and should itself return a Enumerator::Generator.

For example to select the first 5 even numbers starting at 123 should work as:

(123..Float::INFINITY).select{|n|n.even?}.take(5)

but this currently results in an endless loop.

The same problem applies for :map and some other operators on Enumerations

However changing :select and :map to make them work with open ended Enumerations

might also change the api contract as they are currently defined to return an array.

We might want to have a look at the SICSP on streams,

http://mitpress.mit.edu/sicp/full-text/sicp/book/node69.html

I came up with this prototype:

class Enumerator

# return a generator for all elements from enumeration where block returns true

def select &block

Enumerator.new do |y|

self.each do |obj|

if block.call(obj)

y<<obj

end

end

end

end

end

Let's wrap an open ended Range in a Generator:

e=Enumerator.new{|y| (123..Float::INFINITY).each{|n|y<<n}}

e.select{|n|n.even?}.take(5)

=> [124, 126, 128, 130, 132]

voilà!

History

#1 - 06/08/2012 02:27 PM - gregolsen (Innokenty Mikhailov)

You might be interested in Enumerator::Lazy that effectively solves you problem.

(123..Float::INFINITY).lazy.select{|n|n.even?}.take(5).force

It's in trunk already and will be available in ruby 2.0

#2 - 07/14/2012 06:44 PM - shyouhei (Shyouhei Urabe)

- Status changed from Open to Feedback

#3 - 11/24/2012 02:19 PM - mame (Yusuke Endoh)
http://mitpress.mit.edu/sicp/full-text/sicp/book/node69.html


- Status changed from Feedback to Rejected

I agree with gregolsen.  No feedback.  Closing.

--

Yusuke Endoh mame@tsg.ne.jp
